#!/usr/bin/python
##### Smerni diagram kvadratne napake faze v ravnini H - S53MV 28.12.2017 #####

import math,cmath	#uporabljene funkcije

k=0.001		#korak risanja v radianih
s=20.0/math.log(10.0)
w=10.0		#sirina lijaka v valovnih dolzinah

def vsota(w,t,d):	#integracija vsote sevanja
	n=1000.0
	kw=w/n
	v=complex(0.0,0.0)
	x=(kw-w)/2.0
	r=0
	while x<w/2.0:
		a=2.0*math.pi*x*math.sin(t)	#zakasnitev
		a=a+d*((2.0*x/w)**2)	#dodaj kvadratno napako faze
		c=math.cos(math.pi*x/w)
		v=v+c*cmath.exp(complex(0.0,a))
		r=r+c
		x=x+kw
	return abs(v)/r

x=[]		#polja za risanje grafa
y=[]
z1=[]
z2=[]
z4=[]

t=k/2.0		#kot theta v radianih
while t<=math.pi/2.0:
	x=x+[t]			#dodaj tocko v risbo
	f=(1.0+math.cos(t))/2.0
	ff=f*math.cos(w*math.pi*math.sin(t))/(1.0-(w*2.0*math.sin(t))**2) #brez napake faze
	y=y+[s*math.log(math.fabs(ff))]
	d=3.0*math.pi/8.0	#kvadratna napaka faze 3pi/8
	z1=z1+[s*math.log(math.fabs(f*vsota(w,t,d)))]
	d=3.0*math.pi/4.0	#kvadratna napaka faze 3pi/4
	z2=z2+[s*math.log(math.fabs(f*vsota(w,t,d)))]
	d=3.0*math.pi/2.0	#kvadratna napaka faze 3pi/2
	z4=z4+[s*math.log(math.fabs(f*vsota(w,t,d)))]
	t=t+k			#povecaj t za korak

import matplotlib.pyplot as plt		#risanje grafa funkcije
plt.plot(x,y,'r-',lw=2)
plt.plot(x,z1,'c-',lw=2)
plt.plot(x,z2,'b-',lw=2)
plt.plot(x,z4,'y-',lw=2)
plt.grid(True)
plt.axis([0.0,math.pi/2,-40,2])
plt.xticks([0.0,math.pi/8,math.pi/4,3*math.pi/8,math.pi/2])
plt.yticks([-40,-35,-30,-25,-20,-15,-10,-5,0])
plt.ylabel('Logaritemsko merilo [dB]')
plt.title('Kvadratna napaka faze v ravnini H')
plt.show()

#konec programa

